#include "lander.h"

bool lander_remove_entry(event_loop_conn *conn) {
  http_loop_ctx *ctx = conn->ctx;
  lander_ctx *c_ctx = ctx->c;
  http_loop_gctx *gctx = ctx->g;
  lander_gctx *c_gctx = gctx->c;

  const char *key_s = &ctx->req.path[ctx->req.regex_groups[1].rm_so];
  int key_len = ctx->req.regex_groups[1].rm_eo - ctx->req.regex_groups[1].rm_so;

  lsm_str *key;
  lsm_str_init_copy_n(&key, (char *)key_s, key_len);

  switch (lsm_store_open_write(&c_ctx->entry, c_gctx->store, key)) {
  case lsm_error_ok:
    break;
  case lsm_error_not_found:
    ctx->res.status = http_not_found;
    return true;
  default:
    ctx->res.status = http_internal_server_error;
    return true;
  }

  lsm_entry_remove(c_ctx->entry);

  return true;
}
