#include <string.h>

#include "lander.h"

bool lander_stream_body_to_entry(event_loop_conn *conn) {
  http_loop_ctx *ctx = conn->ctx;
  lander_ctx *c_ctx = ctx->c;

  uint64_t to_append =
      MIN(conn->rbuf_size - conn->rbuf_read,
          ctx->req.body.expected_len - lsm_entry_data_len(c_ctx->entry));

  lsm_str *data;
  lsm_str_init_copy_n(&data, (char *)&conn->rbuf[conn->rbuf_read], to_append);
  lsm_entry_data_append(c_ctx->entry, data);

  conn->rbuf_read += to_append;

  lsm_str_free(data);

  return lsm_entry_data_len(c_ctx->entry) == ctx->req.body.expected_len;
}
